//============================================================================
// Name        : reverse_mutator.cpp
// Author      : al.zatv  zatv@bk.ru
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

// taken from:
//=======================================================================
// Copyright 1997, 1998, 1999, 2000 University of Notre Dame.
// Authors: Andrew Lumsdaine, Lie-Quan Lee, Jeremy G. Siek
//
// Distributed under the Boost Software License, Version 1.0. (See
// accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)
//=======================================================================
#include <boost/graph/graph_concepts.hpp>
#include <boost/graph/graph_archetypes.hpp>
#include <boost/graph/adjacency_list.hpp>
#include "reverse_graph_mutable.hpp"

#include <iostream>
#include <fstream>
#include <boost/graph/graphviz.hpp>
#include "reverse_graph_mutable.hpp"

void test_in_work()
{
	using namespace std;
	using namespace boost;

    adjacency_list<vecS,vecS> G;
    auto rG=make_reverse_graph(G);
    auto vd0=add_vertex(rG);    auto vd1=add_vertex(rG);    auto vd2=add_vertex(rG);    auto vd3=add_vertex(rG);

    add_edge(vd3,vd2,rG);
    add_edge(vd0,vd1,rG);    add_edge(vd0,vd2,rG);    add_edge(vd1,vd3,rG);    add_edge(vd0,vd3,rG);

    auto vdX=add_vertex(rG);

    adjacency_list<vecS,vecS>::edge_descriptor ede;
    std::tie(ede,ignore)=add_edge(vd0,vdX,rG);
    remove_edge(ede,rG);
    remove_vertex(vdX,rG);

    auto allE=edges(rG);
    remove_edge(allE.first,rG);

    {
    	ofstream fout("del-test.dot");
    	write_graphviz(fout,G);
    }
    system("dotty del-test.dot");


	return;
}



/* ****************************************
 *main
 **************************************** */
int main(int,char*[])
{
	test_in_work();

  using namespace boost;

  {
    typedef adjacency_list<vecS, vecS, bidirectionalS,
      property<vertex_color_t, int>,
      property<edge_weight_t, int>
    > normGraph;
    typedef reverse_graph<normGraph,normGraph&> Graph;

    typedef graph_traits<Graph>::vertex_descriptor Vertex;
    typedef graph_traits<Graph>::edge_descriptor Edge;
    function_requires< VertexListGraphConcept<Graph> >();
    function_requires< EdgeListGraphConcept<Graph> >();
    function_requires< IncidenceGraphConcept<Graph> >();
    function_requires< AdjacencyGraphConcept<Graph> >();
    function_requires< BidirectionalGraphConcept<Graph> >();
//TODO:    function_requires< MutableBidirectionalGraphConcept<Graph> >();
    function_requires< MutableEdgeListGraphConcept<Graph> >();
    function_requires< VertexMutablePropertyGraphConcept<Graph> >();
    function_requires< EdgeMutablePropertyGraphConcept<Graph> >();
    function_requires<
      ReadablePropertyGraphConcept<Graph, Vertex, vertex_index_t> >();
    function_requires<
      LvaluePropertyGraphConcept<Graph, Vertex, vertex_color_t> >();
    function_requires<
      LvaluePropertyGraphConcept<Graph, Edge, edge_weight_t> >();
  }

  // Checking adjacency_list with EdgeList=setS
  {
    typedef adjacency_list<setS, vecS, bidirectionalS,
      property<vertex_color_t, int>,
      property<edge_weight_t, int>
    > fwdGraph;
    typedef reverse_graph<fwdGraph,fwdGraph&> Graph;

    typedef graph_traits<Graph>::vertex_descriptor Vertex;
    typedef graph_traits<Graph>::edge_descriptor Edge;
    function_requires< VertexListGraphConcept<Graph> >();
    function_requires< EdgeListGraphConcept<Graph> >();
    function_requires< IncidenceGraphConcept<Graph> >();
    function_requires< AdjacencyGraphConcept<Graph> >();
    function_requires< BidirectionalGraphConcept<Graph> >();
//TODO:    function_requires< MutableBidirectionalGraphConcept<Graph> >();
    function_requires< MutableEdgeListGraphConcept<Graph> >();
    function_requires< VertexMutablePropertyGraphConcept<Graph> >();
    function_requires< EdgeMutablePropertyGraphConcept<Graph> >();
    function_requires<
      ReadablePropertyGraphConcept<Graph, Vertex, vertex_index_t> >();
    function_requires<
      LvaluePropertyGraphConcept<Graph, Vertex, vertex_color_t> >();
    function_requires<
      LvaluePropertyGraphConcept<Graph, Edge, edge_weight_t> >();
  }
  {
    typedef adjacency_list<vecS, vecS, bidirectionalS> fwdGraph;
    typedef reverse_graph<fwdGraph,fwdGraph&> Graph;

    typedef graph_traits<Graph>::vertex_descriptor Vertex;
    typedef graph_traits<Graph>::edge_descriptor Edge;
    function_requires< VertexListGraphConcept<Graph> >();
    function_requires< EdgeListGraphConcept<Graph> >();
    function_requires< IncidenceGraphConcept<Graph> >();
    function_requires< AdjacencyGraphConcept<Graph> >();
    function_requires< BidirectionalGraphConcept<Graph> >();
//TODO:    function_requires< MutableBidirectionalGraphConcept<Graph> >();
    function_requires< MutableEdgeListGraphConcept<Graph> >();
    function_requires<
      ReadablePropertyGraphConcept<Graph, Vertex, vertex_index_t> >();
  }
  // Checking EdgeList=setS with no properties
  {
    typedef adjacency_list<setS, vecS, bidirectionalS> fwdGraph;
    typedef reverse_graph<fwdGraph,fwdGraph&> Graph;

    typedef graph_traits<Graph>::vertex_descriptor Vertex;
    typedef graph_traits<Graph>::edge_descriptor Edge;
    function_requires< VertexListGraphConcept<Graph> >();
    function_requires< EdgeListGraphConcept<Graph> >();
    function_requires< IncidenceGraphConcept<Graph> >();
    function_requires< AdjacencyGraphConcept<Graph> >();
    function_requires< BidirectionalGraphConcept<Graph> >();
//TODO:    function_requires< MutableBidirectionalGraphConcept<Graph> >();
    function_requires< MutableEdgeListGraphConcept<Graph> >();
    function_requires< ReadablePropertyGraphConcept<Graph,
      Vertex, vertex_index_t> >();
  }
  return 0;
}


